Subject: Re: Why does exec_simple_query requires 2 snapshots

From: Tom Lane <[email-masked]>
Date: Tue, 18 Feb 2025 10:43:40 -0500

Andy Fan <[email-masked]> writes:
> My question is why can't we share the same snapshot for the 2 cases?
> parser & planner requires Catalog Snapshot which should be the 
> latest one, but in the above case, looks the executor can reuse it as
> well. Is there anything I missed?

Many years ago, we committed a patch to do exactly that.  We had
to back it out again because it broke too many real-world scenarios.
I'm too lazy to search the archives for you, but you might be able
to find the commit and revert by searching the git history.

			regards, tom lane